#!/usr/bin/perl

#
# Pretty printer for snort logs
#
# Angelos Karageorgiou angelos@unix.gr
#


$targetlen=25;
$sourcelen=35;
$protolen=12;

use Socket;


open(LOG,"< /var/log/secure") || die "No can do";

printf("%15s %-35s %-25s %-25s\n","DATE","  WARNING", "FROM", "TO");
print "=" x 100;
print "\n";
while(<LOG>) {
	chomp();
	if ( 
		( !  /.*snort*/gi )
	   ) { next ; }

	$_ =~ s/ gate snort//gi ;
	$date=substr($_,0,15);
	$rest=substr($_,16,500);



	@fields=split(": ", $rest);
	$text=$fields[0];


	$fields[1] =~ s/ \-\> /-/gi;
	($source,$dest)=split('-', $fields[1]);


	($host,$port)=split(':',$source);
	


  	$iaddr = inet_aton($host); # or whatever address
    	$name  = gethostbyaddr($iaddr, AF_INET);            
	if ( $name =~ /^$/ ) {
		$name=$host;
	}
	if ( $name =~ /apg.the.forthnet.gr/gi ) {
		next;
	}
	$name = $name . ":" .  $port;

	$skipit=0;

	($shost,$sport)=split(':',$dest);
	$sport =~ s/ //gi;
  	$siaddr = inet_aton($shost); # or whatever address
    	$sname  = gethostbyaddr($siaddr, AF_INET) ;            
	if ( $sname =~ /^$/ ) {
		$sname=$shost;
	}
	$sname = $sname . ":" .  $sport;
	printf("%15s %-32s %-30s %s\n",
		$date, $text,
		$name,$sname);

}
close(LOG);

